<?php
/*
    Language:	English
    Platform:	Joomla 3.x
    Author:	J. Lipman (info@joellipman.com)
    Website:	www.joellipman.com
    Copyright:	Copyright (C) 2010 Joellipman.Com
    License:	GNU/GPL http://www.gnu.org/copyleft/gpl.html

    Program:	Module Revolver Map
    Version:	1.1
    Created:	17/03/2015
    Modified:	-

    Script Function:
	This displays a google map in a module with some styling features.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// Google Map API v3 documentation:
// https://developers.google.com/maps/tutorials/fundamentals/adding-a-google-map

// get google map API scripts
$jgm_document = JFactory::getDocument();
$jgm_document->addScript('https://maps.googleapis.com/maps/api/js');

// get defined variables
$jgm_param_class = trim($params->get('JGM_paramCLASS'));							// v1.0
$jgm_param_zoom = trim($params->get('JGM_paramZOOM'))*1;								// v1.1
$jgm_param_width = trim($params->get('JGM_paramWIDTH'));							// v1.1
$jgm_param_height = trim($params->get('JGM_paramHEIGHT'));							// v1.1
$jgm_param_lat = trim($params->get('JGM_paramLAT'))*1;							// v1.1
$jgm_param_lng = trim($params->get('JGM_paramLNG'))*1;							// v1.1
$jgm_param_heading = trim($params->get('JGM_paramHEADING'))*1;							// v1.1
$jgm_param_tilt = trim($params->get('JGM_paramTILT'))*1;							// v1.1
$jgm_param_marker1_show = (trim($params->get('JGM_paramMARKER1'))*1==1) ? true : false;							// v1.1
$jgm_param_marker1_title = trim($params->get('JGM_paramMARKER1TITLE'));							// v1.1
$jgm_param_marker1_lat = trim($params->get('JGM_paramMARKER1LAT'))*1;							// v1.1
$jgm_param_marker1_lng = trim($params->get('JGM_paramMARKER1LNG'))*1;							// v1.1
$jgm_param_marker1_img = trim($params->get('JGM_paramMARKER1IMG'));							// v1.1
$jgm_param_marker1_html = trim($params->get('JGM_paramMARKER1HTML'));							// v1.1
$jgm_param_css_border_color = trim($params->get('JGM_paramCSSBORDERCOLOR'));							// v1.1
$jgm_param_css_border_width = trim($params->get('JGM_paramCSSBORDERWIDTH'));							// v1.1
$jgm_param_maptype_id = trim($params->get('JGM_paramMAPTYPE'))*1;							// v1.1

// get map controls
$jgm_param_control_zoom = trim($params->get('JGM_paramCONTROLZOOM'))*1;							// v1.1
$jgm_param_control_maptype = trim($params->get('JGM_paramCONTROLMAPTYPE'))*1;							// v1.1
$jgm_param_control_pan_boo = (trim($params->get('JGM_paramCONTROLSPAN'))*1==1) ? true : false;							// v1.1
$jgm_param_control_scale_boo = (trim($params->get('JGM_paramCONTROLSCALE'))*1==1) ? true : false;							// v1.1
$jgm_param_control_street_boo = (trim($params->get('JGM_paramCONTROLSTREET'))*1==1) ? true : false;							// v1.1
$jgm_param_control_rotate_boo = (trim($params->get('JGM_paramCONTROLROTATE'))*1==1) ? true : false;							// v1.1
$jgm_param_control_overview_boo = (trim($params->get('JGM_paramCONTROLOVERVIEW'))*1==1) ? true : false;							// v1.1

// determine variables
$jgm_param_maptypes = array('ROADMAP','SATELLITE','HYBRID','TERRAIN');  // v1.1
$jgm_param_maptype = $jgm_param_maptypes[$jgm_param_maptype_id];							// v1.1
$jgm_param_control_z_opts = array('','google.maps.ZoomControlStyle.DEFAULT','google.maps.ZoomControlStyle.SMALL','google.maps.ZoomControlStyle.LARGE');  // v1.1
$jgm_param_control_z_opt = $jgm_param_control_z_opts[$jgm_param_control_zoom];							// v1.1
$jgm_param_control_m_opts = array('','google.maps.MapTypeControlStyle.DEFAULT','google.maps.MapTypeControlStyle.HORIZONTAL_BAR','google.maps.MapTypeControlStyle.DROPDOWN_MENU');  // v1.1
$jgm_param_control_m_opt = $jgm_param_control_z_opts[$jgm_param_control_zoom];							// v1.1




// Styler: all
$jgm_param_style['all'] = array();
$jgm_param_style['all']['in_use'] = (trim($params->get('JGM_paramSTYLEALL_USE'))*1==1) ? true : false;							// v1.1
if($jgm_param_style['all']['in_use']){
	$jgm_param_style['all']['hue'] = trim($params->get('JGM_paramSTYLEALLHUE'));							// v1.1
	$jgm_param_style['all']['lightness'] = trim($params->get('JGM_paramSTYLEALLLIGHTNESS'));							// v1.1
	$jgm_param_style['all']['saturation'] = trim($params->get('JGM_paramSTYLEALLSATURATION'));							// v1.1
	$jgm_param_style['all']['gamma'] = trim($params->get('JGM_paramSTYLEALLGAMMA'));							// v1.1
	$jgm_param_style['all']['invert_lightness'] = (trim($params->get('JGM_paramSTYLEALLINVERT'))*1==1) ? 'true' : '';								// v1.1
	$jgm_param_style['all']['color'] = trim($params->get('JGM_paramSTYLEALLCOLOR'));							// v1.1
	$jgm_param_style['all']['weight'] = trim($params->get('JGM_paramSTYLEALLWEIGHT'));							// v1.1
}

// Styler: road.arterial
$jgm_param_style['road.arterial'] = array();
$jgm_param_style['road.arterial']['in_use'] = (trim($params->get('JGM_paramSTYLEROADARTERIAL_USE'))*1==1) ? true : false;							// v1.1
if($jgm_param_style['road.arterial']['in_use']){
	$jgm_param_style['road.arterial']['hue'] = trim($params->get('JGM_paramSTYLEROADARTERIALHUE'));							// v1.1
	$jgm_param_style['road.arterial']['lightness'] = trim($params->get('JGM_paramSTYLEROADARTERIALLIGHTNESS'));							// v1.1
	$jgm_param_style['road.arterial']['saturation'] = trim($params->get('JGM_paramSTYLEROADARTERIALSATURATION'));							// v1.1
	$jgm_param_style['road.arterial']['gamma'] = trim($params->get('JGM_paramSTYLEROADARTERIALGAMMA'));							// v1.1
	$jgm_param_style['road.arterial']['invert_lightness'] = (trim($params->get('JGM_paramSTYLEROADARTERIALINVERT'))*1==1) ? 'true' : '';							// v1.1
	$jgm_param_style['road.arterial']['color'] = trim($params->get('JGM_paramSTYLEROADARTERIALCOLOR'));							// v1.1
	$jgm_param_style['road.arterial']['weight'] = trim($params->get('JGM_paramSTYLEROADARTERIALWEIGHT'));							// v1.1
	$jgm_param_style['road.arterial']['visibility'] = (trim($params->get('JGM_paramSTYLEROADARTERIALVISIBILITY'))*1==1) ? 'on' : 'off';							// v1.1
}

// Styler: poi.business
$jgm_param_style['poi.business'] = array();
$jgm_param_style['poi.business']['in_use'] = (trim($params->get('JGM_paramSTYLEPOIBUSINESS_USE'))*1==1) ? true : false;							// v1.1
if($jgm_param_style['poi.business']['in_use']){
	$jgm_param_style['poi.business']['hue'] = trim($params->get('JGM_paramSTYLEPOIBUSINESSHUE'));							// v1.1
	$jgm_param_style['poi.business']['lightness'] = trim($params->get('JGM_paramSTYLEPOIBUSINESSLIGHTNESS'));							// v1.1
	$jgm_param_style['poi.business']['saturation'] = trim($params->get('JGM_paramSTYLEPOIBUSINESSSATURATION'));							// v1.1
	$jgm_param_style['poi.business']['gamma'] = trim($params->get('JGM_paramSTYLEPOIBUSINESSGAMMA'));							// v1.1
	$jgm_param_style['poi.business']['invert_lightness'] = (trim($params->get('JGM_paramSTYLEPOIBUSINESSINVERT'))*1==1) ? 'true' : '';							// v1.1
	$jgm_param_style['poi.business']['color'] = trim($params->get('JGM_paramSTYLEPOIBUSINESSCOLOR'));							// v1.1
	$jgm_param_style['poi.business']['weight'] = trim($params->get('JGM_paramSTYLEPOIBUSINESSWEIGHT'));							// v1.1
	$jgm_param_style['poi.business']['visibility'] = (trim($params->get('JGM_paramSTYLEPOIBUSINESSVISIBILITY'))*1==1) ? 'on' : 'off';							// v1.1
}

// cycle through stylers
$jgm_param_style_arr = array();
$jgm_param_styles_arr = array();

$jgm_param_style_feature_array = array('all','road.arterial','poi.business');
$jgm_param_style_element_array = array('','geometry','labels');

$jgm_param_style_attr_str_array = array('hue','color','visibility');
$jgm_param_style_attr_num_array = array('lightness','saturation','gamma','invert_lightness','weight');

// loop through for style
for($jgm_j=0;$jgm_j<count($jgm_param_style_feature_array);$jgm_j++){
	$this_feature_type = $jgm_param_style_feature_array[$jgm_j];
	$this_element_type_str = ($this_feature_type=="all") ? '' : ', elementType: "'.$jgm_param_style_element_array[$jgm_j].'"';

	for($jgm_i=0;$jgm_i<count($jgm_param_style_attr_str_array);$jgm_i++){
		$this_attr_lbl=$jgm_param_style_attr_str_array[$jgm_i];
		$this_attr_val=$jgm_param_style[$this_feature_type][$jgm_param_style_attr_str_array[$jgm_i]];
		if($this_attr_val!="")
			$jgm_param_style_arr[$this_feature_type][] = '{ '.$this_attr_lbl.': "'.trim($this_attr_val).'" }';	// v1.1
	}
	for($jgm_i=0;$jgm_i<count($jgm_param_style_attr_num_array);$jgm_i++){
		$this_attr_lbl=$jgm_param_style_attr_num_array[$jgm_i];
		$this_attr_val=$jgm_param_style[$this_feature_type][$jgm_param_style_attr_num_array[$jgm_i]];
		if($this_attr_val!="")
			$jgm_param_style_arr[$this_feature_type][] = '{ '.$this_attr_lbl.': "'.trim($this_attr_val).'" }';	// v1.1
	}
	if(count($jgm_param_style_arr[$this_feature_type])>0){
		$this_feature_enabled = $jgm_param_style[$this_feature_type]['in_use'];
		if($this_feature_enabled)
			$jgm_param_styles_arr[] = '{ featureType: "'.$this_feature_type.'"'.$this_element_type_str.', stylers: [ '. implode(", ", $jgm_param_style_arr[$this_feature_type]) .' ] }';
	}


}
// convert array to string
$jgm_param_styles_str = implode(", ", $jgm_param_styles_arr);

// generate marker string
$jgm_param_marker1_show_str=($jgm_param_marker1_show)?'
        var marker_1_latlng = new google.maps.LatLng('.$jgm_param_marker1_lat.', '.$jgm_param_marker1_lng.');
	    var marker_1_html = \'<div id="content">'.addslashes($jgm_param_marker1_html).'</div>\';

        var infowindow = new google.maps.InfoWindow({
            content: marker_1_html
        });

		var marker_1_img = \''.$jgm_param_marker1_img.'\';
        var marker_1 = new google.maps.Marker({
            position: marker_1_latlng,
            map: map,
            title: \''.addslashes($jgm_param_marker1_title).'\',
			icon: marker_1_img
        });
        google.maps.event.addListener(marker_1, \'click\', function() {
            infowindow.open(map,marker_1);
        });
//		infowindow.open(map,marker_1);
':'';

// control types
$jgm_param_control_types = array('mapTypeControl','panControl','zoomControl','scaleControl','rotateControl','overviewMapControl');
$jgm_param_control_types_options = array('mapTypeControlOptions','panControlOptions','zoomControlOptions','scaleControlOptions','rotateControlOptions','overviewMapControlOptions');
$jgm_param_control_positions = array('TOP_CENTER','TOP_LEFT','TOP_RIGHT','LEFT_TOP','RIGHT_TOP','LEFT_CENTER','RIGHT_CENTER','LEFT_BOTTOM','RIGHT_BOTTOM','BOTTOM_CENTER','BOTTOM_LEFT','BOTTOM_RIGHT');

if($jgm_param_control_z_opt!=""){
	$jgm_param_control_z_opts_str="zoomControlOptions: { style: ".$jgm_param_control_z_opt." }";
}
if($jgm_param_control_m_opt!=""){
	$jgm_param_control_m_opts_str="mapTypeControlOptions: { style: ".$jgm_param_control_m_opt." }";
}

// MapOptions: basics
$jgm_js_map_options=array();
$jgm_js_map_options[]='center: new google.maps.LatLng('.$jgm_param_lat.', '.$jgm_param_lng.')';
$jgm_js_map_options[]='zoom: '.$jgm_param_zoom;
if(trim($jgm_param_maptype)!="")$jgm_js_map_options[]='mapTypeId: google.maps.MapTypeId.'.$jgm_param_maptype;
if(trim($jgm_param_heading)!="")$jgm_js_map_options[]='heading: '.$jgm_param_heading;
if(trim($jgm_param_tilt)!="")$jgm_js_map_options[]='tilt: '.$jgm_param_tilt;

// MapOptions: controls to add
if($jgm_param_control_pan_boo)$jgm_js_map_options[]='panControl: '.$jgm_param_control_pan;
if($jgm_param_control_zoom>0)$jgm_js_map_options[]='zoomControl: '.$jgm_param_control_zoom;
if($jgm_param_control_zoom>0)$jgm_js_map_options[]='zoomControlOptions: {'.$jgm_param_control_z_opts_str.'}';
if($jgm_param_control_maptype>0)$jgm_js_map_options[]='mapTypeControl: '.$jgm_param_control_maptype;
if($jgm_param_control_maptype>0)$jgm_js_map_options[]='mapTypeControlOptions: {'.$jgm_param_control_m_opts_str.'}';
if($jgm_param_control_scale_boo)$jgm_js_map_options[]='scaleControl: '.$jgm_param_control_scale;
if($jgm_param_control_street_boo)$jgm_js_map_options[]='streetViewControl: '.$jgm_param_control_street;
if($jgm_param_control_overview_boo)$jgm_js_map_options[]='overviewMapControl: '.$jgm_param_control_overview;
// if($jgm_param_control_rotate_boo)$jgm_js_map_options[]='rotateControl: '.$jgm_param_control_rotate;

// Create JavaScript for Google Map
$jgm_map_script = '
    function jgm_fn_init() {

        // Create an array of styles.
        var styleArray = [
          '.$jgm_param_styles_str.'
        ];

        // Create a new StyledMapType object, passing it the array of styles,
        // as well as the name to be displayed on the map type control.
        var styledMap = new google.maps.StyledMapType(styleArray, {name: "Havana Winebar Map"});

        var mapCanvas = document.getElementById(\'map-canvas\');
        var mapOptions = {
            '.implode(', ', $jgm_js_map_options).'
        }
        var map = new google.maps.Map(mapCanvas, mapOptions);

        // DECLARE STUFF HERE AFTER THE MAP !!!
		'.$jgm_param_marker1_show_str.'
        map.mapTypes.set(\'map_style\', styledMap);
        map.setMapTypeId(\'map_style\');

      }
      google.maps.event.addDomListener(window, \'load\', jgm_fn_init);
';

// Add JavaScript
$jgm_document->addScriptDeclaration($jgm_map_script);

// Create CSS String for Google Map
$jgm_style = '#map-canvas { width: '.$jgm_param_width.'; height: '.$jgm_param_height.'; }';

// Add StyleSheet
$jgm_document->addStyleDeclaration($jgm_style);

$this_div_style_inline_arr=array();
if(($jgm_param_css_border_color!="transparent")&&($jgm_param_css_border_color!="")) $this_div_style_inline_arr[]='background-color: '.$jgm_param_css_border_color;
if($jgm_param_css_border_width>0) $this_div_style_inline_arr[]='padding: '.$jgm_param_css_border_width.'px';
if(count($this_div_style_inline_arr)>0){
	$this_div_style_inline_str=' style="'.implode("; ", $this_div_style_inline_arr).'"';
}
?>

<div<?php echo $this_div_style_inline_str; ?>>
	<div id="map-canvas"></div>

</div>